#!/usr/local/bin/perl
# save_user.cgi
# Create, update or delete a user

require './virtual-server-lib.pl';
&ReadParse();
$d = &get_domain($in{'dom'});
&can_edit_domain($d) || &error($text{'users_ecannot'});
@users = &list_domain_users($d);
if (!$in{'new'}) {
	# Lookup user details
	($user) = grep { $_->{'user'} eq $in{'old'} } @users;
	$user || &error("User does not exist!");
	%old = %$user;
	$mailbox = $d->{'user'} eq $user->{'user'};
	}
&error_setup($text{'user_err'});

&build_taken(\%taken, \%utaken);

if ($in{'delete'}) {
	if ($in{'confirm'}) {
		# Get rid of his mail file
		$mailbox && &error($text{'user_edelete'});
		&delete_mail_file($user);

		# Delete the user, his virtusers and aliases
		&delete_user($user, $d);

		# Delete home dir
		system("rm -rf '$user->{'home'}'")
		  if (-d $user->{'home'} && $user->{'home'} ne "/");
		}
	else {
		# Confirm deletion first
		&header($text{'user_delete'}, "");
		&domain_title($d);
		print "<hr>\n";

		print "<form action=save_user.cgi>\n";
		print "<input type=hidden name=dom value='$in{'dom'}'>\n";
		print "<input type=hidden name=old value='$in{'old'}'>\n";
		print "<input type=hidden name=delete value=1>\n";
		local ($mailsz) = &mail_file_size($user);
		local ($homesz) = &disk_usage_kb($user->{'home'});
		print "<p>",&text('user_rusure', "<tt>$in{'old'}</tt>",
			  	  &nice_size($mailsz),
				  &nice_size($homesz*1024),
				  "<tt>$user->{'home'}</tt>"),"<p>\n";
		print "<center><input type=submit name=confirm ",
		      "value='$text{'user_deleteok'}' ",
		      "onClick='check_clicks(form)'></center>\n";
		print "</form>\n";

		print "<hr>\n";
		&footer("list_users.cgi?dom=$in{'dom'}", $text{'users_return'});
		exit;
		}
	}
else {
	# Verify inputs
	if ($in{'new'} && $d->{'mailboxlimit'}) {
		if (@users >= $d->{'mailboxlimit'}) {
			&error($text{'user_emailboxlimit'});
			}
		}
	if (!$mailbox) {
		$in{'user'} = lc($in{'user'});
		$in{'user'} =~ /^[^ \t:]+$/ || &error($text{'user_euser'});
		$in{'real'} =~ /^[^:]*$/ || &error($text{'user_ereal'});
		$user->{'real'} = $in{'real'};
		if ($in{'pass_def'}) {
			$user->{'passmode'} = 4;
			}
		else {
			$user->{'pass'} =
				&useradmin::encrypt_password($in{'pass'});
			$user->{'plainpass'} = $in{'pass'};
			$user->{'passmode'} = 3;
			&set_pass_change($user);
			}
		$qsame = $config{'mail_quotas'} eq $config{'home_quotas'};
		if ($config{'home_quotas'}) {
			if ( $in{'quota'} eq -1 ) {
				$in{'quota'} = $in{'otherquota'};
				}
			$in{'quota_def'} || $in{'quota'} =~ /^\d+$/ ||
				&error($text{'user_equota'});
			}
		if ($config{'mail_quotas'} && !$qsame) {
			if ( $in{'mquota'} eq -1 ) {
				$in{'mquota'} = $in{'othermquota'};
				}
			$in{'mquota_def'} || $in{'mquota'} =~ /^\d+$/ ||
				&error($text{'user_equota'});
			}
		}
	@extra = split(/\s+/, $in{'extra'});
	foreach $e (@extra) {
		$e = lc($e);
		if ($e =~ /^([^\@ \t]+$)$/) {
			$e = "$e\@$d->{'dom'}";
			}
		if ($e !~ /^(\S+)\@(\S+)$/) {
			&error(&text('user_eextra1', $e));
			}
		local ($eu, $ed) = ($1, $2);
		local $edom = &get_domain_by("dom", $ed);
		$edom && $edom->{'mail'} || &error(&text('user_eextra2', $ed));
		&can_edit_domain($edom) || &error(&text('user_eextra3', $ed));
		}
	@values = &parse_alias();
	$user->{'to'} = @values ? \@values : undef;
	$eu = $mailbox ? $d->{'user'} : $in{'user'};
	$user->{'email'} = $in{'mailbox'} ? $eu."\@".$d->{'dom'}
					  : undef;
	$user->{'extraemail'} = \@extra;

	if (!$mailbox) {
		# Find home
		if ((!$access{'noconfig'} || $config{'edit_homes'}) &&
		    $d->{'home'} && !$in{'home_def'}) {
			$in{'home'} =~ /^\S+$/ && $in{'home'} !~ /\.\./ ||
				&error($text{'user_ehome'});
			$home = "$d->{'home'}/$in{'home'}";
			}
		else {
			$home = "$d->{'home'}/homes/$in{'user'}";
			}
		}

	# Create or update the user
	if ($in{'new'}) {
		# Set new user parameters
		$user->{'uid'} = &allocate_uid(\%taken);
		$user->{'gid'} = $d->{'gid'};
		$user->{'shell'} = $in{'ftp'} ? $config{'ftp_shell'}
					      : $config{'shell'};
		$user->{'home'} = $home;
		if ($utaken{$in{'user'}} || $config{'append'}) {
			# Oh no .. name is in use! Add group name
			$user->{'user'} = &userdom_name($in{'user'}, $d);
			}
		else {
			$user->{'user'} = $in{'user'};
			}
		$user->{'passmode'} = 3;
		$user->{'plainpass'} = $in{'pass'};

		# Check for a clash in this domain
		if ($utaken{$user->{'user'}} ||
		    &check_clash($in{'user'}, $d->{'dom'})) {
			&error($text{'user_eclash'});
			}

		# Check if any extras clash
		foreach $e (@extra) {
			$e =~ /^(\S+)\@(\S+)$/;
			if (&check_clash($1, $2)) {
				&error(&text('user_eextra4', $e));
				}
			}

		# Check if the name is too long
		if ($lerr = &too_long($user->{'user'})) {
			&error($lerr);
			}

		# Check if home directory already exists
		if (-e $home) {
			&error(&text('user_emkhome', $home));
			}

		# Create the user and virtusers and alias
		&create_user($user, $d);

		# Create his homedir
		system("mkdir -p '$home'");
		system("chown $user->{'uid'}:$user->{'gid'} '$home'");
		system("chmod 755 '$home'");

		# Copy files into homedir
		&copy_skel_files($config{'mail_skel'}, $user);

		# Send an email upon creation
		@erv = &send_user_email($d, $user);
		}
	else {
		# Check if any extras clash
		%oldextra = map { $_, 1 } @{$old{'extraemail'}};
		foreach $e (@extra) {
			$e =~ /^(\S+)\@(\S+)$/;
			if (!$oldextra{$e} && &check_clash($1, $2)) {
				&error(&text('user_eextra4', $e));
				}
			}

		# For any user except the domain owner, update his home and shel
		if (!$mailbox) {
			# Check if new homedir exists
			if (-e $home && $user->{'home'} ne $home) {
				&error(&text('user_emkhome', $home));
				}

			# Update user parameters (handle rename and .group)
			if ($in{'user'} ne $in{'oldpop3'}) {
				# Has been renamed .. check for a username clash
				if ($utaken{$in{'user'}} || $config{'append'}) {
					# New name has to include group
					$user->{'user'} = &userdom_name($in{'user'},$d);
					}
				else {
					# Can rename without the dot
					$user->{'user'} = $in{'user'};
					}

				# Check if the name is too long
				if ($lerr = &too_long($user->{'user'})) {
					&error($lerr);
					}

				# Check for a virtuser clash too
				if (&check_clash($in{'user'}, $d->{'dom'})) {
					&error($text{'user_eclash'});
					}

				# Rename his mail file
				&rename_mail_file($user, $in{'oldpop3'});
				}

			# Rename homedir
			if ($user->{'home'} ne $home && -d $user->{'home'}) {
				system("mv '$user->{'home'}' '$home'");
				$user->{'home'} = $home;
				}

			# Update shell
			if (defined($in{'ftp'})) {
				$user->{'shell'} = $in{'ftp'} ?
					$config{'ftp_shell'} :
					$config{'shell'};
				}
			}

		# Update the user and any virtusers and aliases
		&modify_user($user, \%old, $d);
		}

	if (!$mailbox) {
		if ($config{'home_quotas'}) {
			# Set his home directory quota
			&set_quota($user->{'user'}, $config{'home_quotas'},
				   $in{'quota_def'} ? 0 : $in{'quota'});
			}
		if ($config{'mail_quotas'} && !$qsame) {
			# Set his home directory quota
			&set_quota($user->{'user'}, $config{'mail_quotas'},
				   $in{'mquota_def'} ? 0 : $in{'mquota'});
			}
		}
	}
&redirect("list_users.cgi?dom=$in{'dom'}");

